-- Source unit class.
INSERT INTO SOURCE_UNIT_CLASS (
	LANGUAGE, 
	LANGUAGE_VERSION, 
	CLASS_NAME
) VALUES (
	'Java',
	'1.4',
	'org.mesopotamia.lang.java.JavaSourceUnit'
);

INSERT INTO SOURCE_UNIT_REQUIRED_LEVEL ( 
	LEVEL_ID,
	SOURCE_UNIT_CLASS_ID
) VALUES (
	(SELECT 
		ID 
	FROM 
		LOADER 
	WHERE 
		LANGUAGE = 'Java' 
		AND LANGUAGE_VERSION = '1.4' 
		AND LEVEL = 'ast'),
	IDENTITY()
); 

-- Language elements
INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='PACKAGE_DEF',
		'org.mesopotamia.lang.java.PackageDefinition',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='IMPORT',
		'org.mesopotamia.lang.java.ImportDefinition',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='TYPE',
		'org.mesopotamia.lang.java.TypeSpecification',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_void',
		'org.mesopotamia.lang.java.Void',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_boolean',
		'org.mesopotamia.lang.java.Boolean',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_byte',
		'org.mesopotamia.lang.java.Byte',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_char',
		'org.mesopotamia.lang.java.Char',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_short',
		'org.mesopotamia.lang.java.Short',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_int',
		'org.mesopotamia.lang.java.Int',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_float',
		'org.mesopotamia.lang.java.Float',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_long',
		'org.mesopotamia.lang.java.Long',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_double',
		'org.mesopotamia.lang.java.Double',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='IDENT',
		'org.mesopotamia.lang.java.Identifier',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='DOT',
		'org.mesopotamia.lang.java.DotFactory',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='MODIFIERS',
		'org.mesopotamia.lang.java.Modifiers',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_private',
		'org.mesopotamia.lang.java.Private',
		 'org.mesopotamia.lang.java.Field' 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_public',
		'org.mesopotamia.lang.java.Public',
		 'org.mesopotamia.lang.java.Field' 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_protected',
		'org.mesopotamia.lang.java.Protected',
		 'org.mesopotamia.lang.java.Field' 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_static',
		'org.mesopotamia.lang.java.Static',
		 'org.mesopotamia.lang.java.Field' 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_transient',
		'org.mesopotamia.lang.java.Transient',
		 'org.mesopotamia.lang.java.VariableDefinition' 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='FINAL',
		'org.mesopotamia.lang.java.Final',
		 'org.mesopotamia.lang.java.ParameterDefinition' 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='FINAL',
		'org.mesopotamia.lang.java.Final',
		 'org.mesopotamia.lang.java.Field' 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='ABSTRACT',
		'org.mesopotamia.lang.java.Abstract',
		 'org.mesopotamia.lang.java.MethodDefinition' 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='ABSTRACT',
		'org.mesopotamia.lang.java.Abstract',
		 'org.mesopotamia.lang.java.TypeDefinition' 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_native',
		'org.mesopotamia.lang.java.Native',
		 'org.mesopotamia.lang.java.MethodDefinition' 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_threadsafe',
		'org.mesopotamia.lang.java.Threadsafe',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_synchronized',
		'org.mesopotamia.lang.java.Synchronized',
		 'org.mesopotamia.lang.java.MethodDefinition' 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_volatile',
		'org.mesopotamia.lang.java.Volatile',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='STRICTFP',
		'org.mesopotamia.lang.java.Strictfp',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='CLASS_DEF',
		'org.mesopotamia.lang.java.ClassDefinition',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='INTERFACE_DEF',
		'org.mesopotamia.lang.java.InterfaceDefinition',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='CTOR_DEF',
		'org.mesopotamia.lang.java.ConstructorDefinition',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='METHOD_DEF',
		'org.mesopotamia.lang.java.MethodDefinition',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='VARIABLE_DEF',
		'org.mesopotamia.lang.java.VariableDefinition',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='STATIC_INIT',
		'org.mesopotamia.lang.java.StaticInitializer',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='INSTANCE_INIT',
		'org.mesopotamia.lang.java.InstanceInitializer',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='CTOR_CALL',
		'org.mesopotamia.lang.java.ExplicitThisConstructorInvocation',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='SUPER_CTOR_CALL',
		'org.mesopotamia.lang.java.ExplicitSuperConstructorInvocation',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='ASSIGN',
		'org.mesopotamia.lang.java.VariableInitializer',
		 'org.mesopotamia.lang.java.VariableDefinition' 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='ARRAY_INIT',
		'org.mesopotamia.lang.java.ArrayInitializer',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='PARAMETER_DEF',
		'org.mesopotamia.lang.java.ParameterDefinition',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='SLIST',
		'org.mesopotamia.lang.java.CompoundStatement',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LABELED_STAT',
		'org.mesopotamia.lang.java.LabeledStatement',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_if',
		'org.mesopotamia.lang.java.If',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_for',
		'org.mesopotamia.lang.java.For',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_while',
		'org.mesopotamia.lang.java.While',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_do',
		'org.mesopotamia.lang.java.Do',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_break',
		'org.mesopotamia.lang.java.Break',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_continue',
		'org.mesopotamia.lang.java.Continue',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_return',
		'org.mesopotamia.lang.java.Return',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_switch',
		'org.mesopotamia.lang.java.Switch',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_throw',
		'org.mesopotamia.lang.java.Throw',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_synchronized',
		'org.mesopotamia.lang.java.SynchronizedStatement',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_assert',
		'org.mesopotamia.lang.java.Assert',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='EMPTY_STAT',
		'org.mesopotamia.lang.java.EmptyStatement',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='CASE_GROUP',
		'org.mesopotamia.lang.java.CasesGroup',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_case',
		'org.mesopotamia.lang.java.Case',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_default',
		'org.mesopotamia.lang.java.Case',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_try',
		'org.mesopotamia.lang.java.TryBlock',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_catch',
		'org.mesopotamia.lang.java.Handler',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='EXPR',
		'org.mesopotamia.lang.java.ExpressionFactory',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='ELIST',
		'org.mesopotamia.lang.java.ExpressionList',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='ASSIGN',
		'org.mesopotamia.lang.java.Assign',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='PLUS_ASSIGN',
		'org.mesopotamia.lang.java.PlusAssign',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='MINUS_ASSIGN',
		'org.mesopotamia.lang.java.MinusAssign',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='STAR_ASSIGN',
		'org.mesopotamia.lang.java.StarAssign',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='DIV_ASSIGN',
		'org.mesopotamia.lang.java.DivAssign',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='MOD_ASSIGN',
		'org.mesopotamia.lang.java.ModAssign',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='SR_ASSIGN',
		'org.mesopotamia.lang.java.ShiftRightAssign',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='BSR_ASSIGN',
		'org.mesopotamia.lang.java.BorrowingShiftRightAssign',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='SL_ASSIGN',
		'org.mesopotamia.lang.java.ShiftLeftAssign',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='BAND_ASSIGN',
		'org.mesopotamia.lang.java.BinaryAndAssign',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='BXOR_ASSIGN',
		'org.mesopotamia.lang.java.BinaryExclusiveOrAssign',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='BOR_ASSIGN',
		'org.mesopotamia.lang.java.BinaryOrAssign',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='QUESTION',
		'org.mesopotamia.lang.java.ConditionalExpression',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LOR',
		'org.mesopotamia.lang.java.LogicalOrExpression',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LAND',
		'org.mesopotamia.lang.java.LogicalAndExpression',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='BOR',
		'org.mesopotamia.lang.java.InclusiveOrExpression',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='BXOR',
		'org.mesopotamia.lang.java.ExclusiveOrExpression',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='BAND',
		'org.mesopotamia.lang.java.AndExpression',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='EQUAL',
		'org.mesopotamia.lang.java.Equal',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='NOT_EQUAL',
		'org.mesopotamia.lang.java.NotEqual',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LT',
		'org.mesopotamia.lang.java.LessThan',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='GT',
		'org.mesopotamia.lang.java.GreaterThan',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LE',
		'org.mesopotamia.lang.java.LessOrEqual',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='GE',
		'org.mesopotamia.lang.java.GreaterOrEqual',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_instanceof',
		'org.mesopotamia.lang.java.InstanceOf',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='SL',
		'org.mesopotamia.lang.java.ShiftLeft',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='SR',
		'org.mesopotamia.lang.java.ShiftRight',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='BSR',
		'org.mesopotamia.lang.java.BorrowingShiftRight',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='PLUS',
		'org.mesopotamia.lang.java.Plus',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='MINUS',
		'org.mesopotamia.lang.java.Minus',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='STAR',
		'org.mesopotamia.lang.java.Star',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='DIV',
		'org.mesopotamia.lang.java.Div',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='MOD',
		'org.mesopotamia.lang.java.Mod',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='INC',
		'org.mesopotamia.lang.java.Inc',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='DEC',
		'org.mesopotamia.lang.java.Dec',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='UNARY_MINUS',
		'org.mesopotamia.lang.java.UnaryMinus',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='UNARY_PLUS',
		'org.mesopotamia.lang.java.UnaryPlus',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='BNOT',
		'org.mesopotamia.lang.java.BinaryNot',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LNOT',
		'org.mesopotamia.lang.java.LogicalNot',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='TYPECAST',
		'org.mesopotamia.lang.java.Typecast',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='METHOD_CALL',
		'org.mesopotamia.lang.java.MethodCall',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_this',
		'org.mesopotamia.lang.java.This',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='INDEX_OP',
		'org.mesopotamia.lang.java.IndexOperation',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='POST_INC',
		'org.mesopotamia.lang.java.PostIncrement',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='POST_DEC',
		'org.mesopotamia.lang.java.PostDecrement',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_true',
		'org.mesopotamia.lang.java.True',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_false',
		'org.mesopotamia.lang.java.False',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_null',
		'org.mesopotamia.lang.java.Null',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_super',
		'org.mesopotamia.lang.java.Super',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LPAREN',
		'org.mesopotamia.lang.java.Parenthesis',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='ARRAY_DECLARATOR',
		'org.mesopotamia.lang.java.ArrayDeclarator',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_class',
		'org.mesopotamia.lang.java.ClassLiteral',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='LITERAL_new',
		'org.mesopotamia.lang.java.NewExpression',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='NUM_INT',
		'org.mesopotamia.lang.java.IntegerConstant',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='CHAR_LITERAL',
		'org.mesopotamia.lang.java.CharacterConstant',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='STRING_LITERAL',
		'org.mesopotamia.lang.java.StringConstant',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='NUM_FLOAT',
		'org.mesopotamia.lang.java.FloatConstant',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='NUM_LONG',
		'org.mesopotamia.lang.java.LongConstant',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	INSERT INTO 
	LANGUAGE_ELEMENT_CLASS (
		TOKEN_TYPE_ID,
		CLASS_NAME,
		CONTEXT_CLASS
	) VALUES (
		SELECT 
			ID
		FROM 
			TOKEN_TYPE
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND TOKEN_NAME='NUM_DOUBLE',
		'org.mesopotamia.lang.java.DoubleConstant',
		 NULL 	);

INSERT INTO 
	LANGUAGE_ELEMENT_REQUIRED_LEVEL (
		LEVEL_ID,
		TOKEN_TYPE_ID
	) VALUES (
		SELECT 
			ID 
		FROM 
			LOADER
		WHERE
			LANGUAGE='Java'
			AND LANGUAGE_VERSION='1.4'
			AND LEVEL='ast',
		IDENTITY()	
	);
	
	