package org.mesopotamia.lang.java;

import java.util.List;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.w3c.dom.Element;

import biz.hammurapi.util.CollectionVisitable;
import biz.hammurapi.util.Visitor;

public class Annotation extends JavaLanguageElement implements AnnotationMemberValueInitializer {

	public Annotation(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes
		Name = selectSingleElementText(Identifier.class, "IDENT|DOT");
		Arguments = select(AnnotationArgument.class, "#org.mesopotamia.lang.java.AnnotationArgument");

	}

	public void toDom(Element holder) {
		super.toDom(holder);

		// Serialize attributes
		setAttribute(holder, "Name", Name);
		setElement(holder, "Arguments", Arguments);
	}

	// Attributes
	private String Name;

	private List<AnnotationArgument> Arguments;

	// Accessors
	public String getName() {
		return Name;
	}

	public List<AnnotationArgument> getArguments() {
		return Arguments;
	}

	protected void acceptChildren(Visitor visitor) {
		super.acceptChildren(visitor);
		// Visiting non-text attributes
		new CollectionVisitable(Arguments, false).accept(visitor);
	}

}
