package org.mesopotamia.lang.java;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.w3c.dom.Element;

import biz.hammurapi.util.Visitable;
import biz.hammurapi.util.Visitor;

public class AnnotationMemberValuePair extends JavaLanguageElement implements AnnotationArgument {

	public AnnotationMemberValuePair(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes
		Name = selectSingleElementText(Identifier.class, "IDENT[0]");
		Value = selectSingleElement(
				AnnotationMemberValueInitializer.class, "*[1]");

	}

	public void toDom(Element holder) {
		super.toDom(holder);

		// Serialize attributes
		setAttribute(holder, "Name", Name);
		setElement(holder, "Value", Value);
	}

	// Attributes
	private String Name;

	private AnnotationMemberValueInitializer Value;

	// Accessors
	public String getName() {
		return Name;
	}

	public AnnotationMemberValueInitializer getValue() {
		return Value;
	}

	protected void acceptChildren(Visitor visitor) {
		super.acceptChildren(visitor);
		// Visiting non-text attributes
		if (Value instanceof Visitable) {
			((Visitable) Value).accept(visitor);
		}
	}

}
