package org.mesopotamia.lang.java;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.w3c.dom.Element;

import biz.hammurapi.util.Visitable;
import biz.hammurapi.util.Visitor;

public class Assert extends JavaLanguageElement implements Statement {

	public Assert(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes
		AssertExpression = (Expression) selectSingleElement(Expression.class, "*[0]");
		MessageExpression = (Expression) selectSingleElement(Expression.class, "*[1]");

	}

	public void toDom(Element holder) {
		super.toDom(holder);

		// Serialize attributes
		setElement(holder, "AssertExpression", AssertExpression);
		setElement(holder, "MessageExpression", MessageExpression);
	}

	// Attributes
	private Expression AssertExpression;

	private Expression MessageExpression;

	// Accessors
	public Expression getAssertExpression() {
		return AssertExpression;
	}

	public Expression getMessageExpression() {
		return MessageExpression;
	}

	protected void acceptChildren(Visitor visitor) {
		super.acceptChildren(visitor);
		// Visiting non-text attributes
		if (AssertExpression instanceof Visitable) {
			((Visitable) AssertExpression).accept(visitor);
		}
		if (MessageExpression instanceof Visitable) {
			((Visitable) MessageExpression).accept(visitor);
		}
	}

}
