package org.mesopotamia.lang.java;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.mesopotamia.lang.java.ref.TypeInfo;

public abstract class BuiltInType extends JavaLanguageElement implements Type {

	public BuiltInType(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes

	}
	
	public static TypeInfo getBuiltInType(String name) {
		if("boolean".equals(name)) return Boolean.BOOLEAN_INFO;
		if("byte".equals(name)) return Byte.BYTE_INFO;
		if("char".equals(name)) return Char.CHAR_INFO;
		if("double".equals(name)) return Double.DOUBLE_INFO;
		if("float".equals(name)) return Float.FLOAT_INFO;
		if("int".equals(name)) return Int.INT_INFO;
		if("long".equals(name)) return Long.LONG_INFO;
		if("short".equals(name)) return Short.SHORT_INFO;
		if("void".equals(name)) return Void.VOID_INFO;
		return null;
	}
	

}
