package org.mesopotamia.lang.java;

import java.util.List;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.w3c.dom.Element;

import biz.hammurapi.util.CollectionVisitable;
import biz.hammurapi.util.Visitor;

public class CasesGroup extends JavaLanguageElement {

	public CasesGroup(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes
		Cases = select(Case.class, "LITERAL_case|LITERAL_default");
		Statements = select(Statement.class, "SLIST/*");

	}

	public void toDom(Element holder) {
		super.toDom(holder);

		// Serialize attributes
		setElement(holder, "Cases", Cases);
		setElement(holder, "Statements", Statements);
	}

	// Attributes
	private List<Case> Cases;

	private List<Statement> Statements;

	// Accessors
	public List<Case> getCases() {
		return Cases;
	}

	public List<Statement> getStatements() {
		return Statements;
	}

	protected void acceptChildren(Visitor visitor) {
		super.acceptChildren(visitor);
		// Visiting non-text attributes
		new CollectionVisitable(Cases, false).accept(visitor);
		new CollectionVisitable(Statements, false).accept(visitor);
	}

}
