package org.mesopotamia.lang.java;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.mesopotamia.lang.java.ref.Reference;
import org.mesopotamia.lang.java.ref.Scope;
import org.mesopotamia.lang.java.ref.TypeInfo;
import org.mesopotamia.lang.java.ref.TypeSpecInfo;

public class ClassLiteral extends PrimaryExpression implements Reference<TypeInfo> {

	public ClassLiteral(
			NodeData xData, 
			Class<?> context, 
			Scan scan,
			RepositoryLanguage language, 
			Object environment) throws MesopotamiaException {
		
		super(xData, context, scan, language, environment);
	}

	public TypeInfo getInfo() {
		Scope ec = findParent(Scope.class);
		return ec==null ? null : ec.findType("java.lang.Class");
	}
	
	@Override
	public TypeSpecInfo getTypeSpecInfo() {
		Scope ec = findParent(Scope.class);		
		if (ec==null) {
			return null;
		}
		final TypeInfo stringInfo = ec.findType("java.lang.Class");
		return stringInfo == null ? null : new TypeSpecInfo() {

			public int getDimensions() {
				return 0;
			}

			public TypeInfo getTypeInfo() {
				return stringInfo;
			}
			
		};
	}

}
