package org.mesopotamia.lang.java;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.mesopotamia.lang.java.ref.MethodInfo;
import org.mesopotamia.lang.java.ref.TypeInfo;
import org.mesopotamia.lang.java.ref.TypeSpecInfo;

public class ConstructorDefinition extends Operation implements MethodInfo {

	public ConstructorDefinition(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes

	}

	public String getFcn() {
		TypeInfo dt = getDeclaringType();
		if (dt==null) {
			return null;
		}
		StringBuffer ret = new StringBuffer();
		ret.append(MethodDefinition.CONSTRUCTOR_NAME);
		ret.append("(");
		boolean first = true;
		for (TypeSpecInfo pd: getParameterTypes()) {
			if (pd==null) {
				return null;
			}
			if (first) {
				first = false;
			} else {
				ret.append(", ");
			}
			TypeInfo pTypeInfo = pd.getTypeInfo();
			if (pTypeInfo == null) {
				return null;
			}
			ret.append(pTypeInfo.getFcn());
			for (int i=0; i<pd.getDimensions(); ++i) {
				ret.append(TypeSpecInfo.ARRAY_BRACKETS);
			}
		}
		ret.append(")");
		first = true;
		for (TypeInfo et: getExceptionTypes()) {
			if (et==null) {
				return null;
			}
			if (first) {
				ret.append(" throws ");
				first = false;
			} else {
				ret.append(", ");
			}
			ret.append(et.getFcn());
		}
		return ret.toString();
	}

	public TypeSpecInfo getReturnType() {
		return new TypeSpecInfo() {

			public int getDimensions() {
				return 0;
			}

			public TypeInfo getTypeInfo() {
				return getDeclaringType();
			}
			
		};
	}

	public String getName() {
		return MethodDefinition.CONSTRUCTOR_NAME;
	}

}
