package org.mesopotamia.lang.java;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.w3c.dom.Element;

import biz.hammurapi.util.Visitable;
import biz.hammurapi.util.Visitor;

public class Do extends JavaLanguageElement implements Statement {

	public Do(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes
		Expression = (Expression) selectSingleElement(Expression.class, "*[1]");
		Statement = (Statement) selectSingleElement(Statement.class, "*[0]");

	}

	public void toDom(Element holder) {
		super.toDom(holder);

		// Serialize attributes
		setElement(holder, "Expression", Expression);
		setElement(holder, "Statement", Statement);
	}

	// Attributes
	private Expression Expression;

	private Statement Statement;

	// Accessors
	public Expression getExpression() {
		return Expression;
	}

	public Statement getStatement() {
		return Statement;
	}

	protected void acceptChildren(Visitor visitor) {
		super.acceptChildren(visitor);
		// Visiting non-text attributes
		if (Expression instanceof Visitable) {
			((Visitable) Expression).accept(visitor);
		}
		if (Statement instanceof Visitable) {
			((Visitable) Statement).accept(visitor);
		}
	}

}
