package org.mesopotamia.lang.java;

import org.mesopotamia.LanguageElement;
import org.mesopotamia.LanguageElementFactory;
import org.mesopotamia.LanguageElementHandle;
import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;

/**
 * Creates identifiers from DOT and IDENT
 * @author Pavel Vlasov
 * @revision $Revision$
 */
public class DotFactory implements LanguageElementFactory {
	
	private LanguageElement languageElement;

	public DotFactory(
			NodeData xData, 
			Class<?> context, 
			Scan scan,
			RepositoryLanguage language, 
			Object environment) throws MesopotamiaException {
		LanguageElement self=new JavaLanguageElement(xData, context, scan, language, environment);
		String tn = language.supportsTokenName("TYPE_ARGUMENTS") ? "!TYPE_ARGUMENTS" : "*";
		LanguageElementHandle providerHandle=self.selectSingleElementHandle(JavaLanguageElement.class, tn+"[0]");
		languageElement=self.selectSingleElement(JavaLanguageElement.class, tn+"[1]");
		((JavaLanguageElement) languageElement).setProviderHandle(providerHandle);
	}

	@SuppressWarnings("unchecked")
	public LanguageElement createLanguageElement(Class targetClass) {
		return languageElement;
	}
}
