package org.mesopotamia.lang.java;

import java.util.List;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.w3c.dom.Element;

import biz.hammurapi.util.CollectionVisitable;
import biz.hammurapi.util.Visitor;

public class EnumDefinition extends TypeDefinition {

	public EnumDefinition(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes
		Implements = selectText(Identifier.class, "IMPLEMENTS_CLAUSE/*");
		Constants = select(EnumConstantDefinition.class, "ENUM_CONSTANT_DEF");

	}

	public void toDom(Element holder) {
		super.toDom(holder);

		// Serialize attributes
		setElement(holder, "Implements", Implements);
		setElement(holder, "Constants", Constants);
	}

	// Attributes
	private List<String> Implements;

	private List<EnumConstantDefinition> Constants;

	// Accessors
	public List<String> getImplements() {
		return Implements;
	}

	public List<EnumConstantDefinition> getConstants() {
		return Constants;
	}

	protected void acceptChildren(Visitor visitor) {
		super.acceptChildren(visitor);
		// Visiting non-text attributes
		new CollectionVisitable(Constants, false).accept(visitor);
	}

}
