package org.mesopotamia.lang.java;

import java.util.List;

import org.mesopotamia.LanguageElement;
import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.MesopotamiaRuntimeException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.mesopotamia.lang.java.ref.Scope;
import org.mesopotamia.lang.java.ref.TypeSpecInfo;

import biz.hammurapi.util.CollectionVisitable;
import biz.hammurapi.util.Visitor;

public class Expression extends JavaLanguageElement implements Initializer, Statement {

	public Expression(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);
		
	}

	protected void acceptChildren(Visitor visitor) {
		super.acceptChildren(visitor);
		// Visiting non-text attributes
		try {
			new CollectionVisitable(getChildren(), false).accept(visitor);
		} catch (MesopotamiaException e) {
			throw new MesopotamiaRuntimeException("Cannot retrieve children", e);
		}		
	}
	
	/**
	 * Override to inform visualizer to show children.
	 */
	@SuppressWarnings("unchecked")
	public synchronized List getChildren() throws MesopotamiaException {
		return super.getChildren();
	}
	
	public TypeSpecInfo getTypeSpecInfo() {
		try {
			LanguageElement firstOperand = getChild(0);
			return firstOperand instanceof Expression ? ((Expression) firstOperand).getTypeSpecInfo() : null;
		} catch (MesopotamiaException e) {
			throw new MesopotamiaRuntimeException(e);
		}
	}
	
}
