package org.mesopotamia.lang.java;

import java.util.List;

import org.mesopotamia.LanguageElement;
import org.mesopotamia.LanguageElementFactory;
import org.mesopotamia.LanguageElementHandle;
import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.MesopotamiaNode;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.mesopotamia.SyntaxTree;

public class ExpressionFactory implements LanguageElementFactory {

	private LanguageElement languageElement;

	@SuppressWarnings("unchecked")
	public ExpressionFactory(
			NodeData xData, 
			Class<?> context, 
			Scan scan,
			RepositoryLanguage language, 
			Object environment) throws MesopotamiaException {
		SyntaxTree st = (SyntaxTree) scan.getSourceUnit(xData.getSourceUnitId()).getLevelData("ast");			
		MesopotamiaNode thisNode = st.findNode(xData.getId());
		List children = thisNode.getChildren();
		NodeData childData = children.isEmpty() ? null : (NodeData) children.get(0);
		if (childData==null) {
			throw new MesopotamiaException("Child at position 0 not found for expression ID: "+xData.getId());
		}
		languageElement=scan.getLanguageElement(new LanguageElementHandle(childData.getSourceUnitId(), childData.getId(), context, Expression.class));
		if (thisNode.getParent()!=null) {
			languageElement.setParentHandle(new LanguageElementHandle(thisNode.getSourceUnitId(), thisNode.getParent().getId(),null,null));
		}
	}

	@SuppressWarnings("unchecked")
	public LanguageElement createLanguageElement(Class targetClass) {
		return languageElement;
	}
}
