package org.mesopotamia.lang.java;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.w3c.dom.Element;

import biz.hammurapi.util.Visitable;
import biz.hammurapi.util.Visitor;

public class ForEachClause extends JavaLanguageElement {

	public ForEachClause(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes
		ParameterDefinition = (ParameterDefinition) selectSingleElement(ParameterDefinition.class, "PARAMETER_DEF");
		Expression = selectSingleElement(Expression.class, "EXPR");

	}

	public void toDom(Element holder) {
		super.toDom(holder);

		// Serialize attributes
		setElement(holder, "ParameterDefinition", ParameterDefinition);
		setElement(holder, "Expression", Expression);
	}

	// Attributes
	private ParameterDefinition ParameterDefinition;

	private Expression Expression;

	// Accessors
	public ParameterDefinition getParameterDefinition() {
		return ParameterDefinition;
	}

	public Expression getExpression() {
		return Expression;
	}

	protected void acceptChildren(Visitor visitor) {
		super.acceptChildren(visitor);
		// Visiting non-text attributes
		if (ParameterDefinition instanceof Visitable) {
			((Visitable) ParameterDefinition).accept(visitor);
		}
		if (Expression instanceof Visitable) {
			((Visitable) Expression).accept(visitor);
		}
	}

}
