package org.mesopotamia.lang.java;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.mesopotamia.lang.java.ref.TypeInfo;
import org.mesopotamia.lang.java.ref.TypeSpecInfo;

public class IntegerConstant extends Constant {

	public IntegerConstant(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);
	}


	public int getValue() {
		if (getText().toLowerCase().startsWith("0x")) {
		    int ret=0;
		    String digits=getText().substring(2);
		    for (int i=0; i<digits.length(); i++) {
		        ret <<= 4;
		        ret |= java.lang.Character.digit(digits.charAt(i), 16);
		    }
			return ret;
		} else {
			return java.lang.Integer.parseInt(getText());
		}
	}

	@Override
	public TypeSpecInfo getTypeSpecInfo() {
		return new TypeSpecInfo() {

			public int getDimensions() {
				return 0;
			}

			public TypeInfo getTypeInfo() {
				return Int.INT_INFO;
				
			}
			
		};
	}
}
