package org.mesopotamia.lang.java;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.w3c.dom.Element;

import biz.hammurapi.util.Visitable;
import biz.hammurapi.util.Visitor;

public class LabeledStatement extends JavaLanguageElement implements Statement {

	public LabeledStatement(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes
		Label = selectSingleElementText(Identifier.class, "*[0]");
		Statement = (Statement) selectSingleElement(Statement.class, "*[1]");

	}

	public void toDom(Element holder) {
		super.toDom(holder);

		// Serialize attributes
		setAttribute(holder, "Label", Label);
		setElement(holder, "Statement", Statement);
	}

	// Attributes
	private String Label;

	private Statement Statement;

	// Accessors
	public String getLabel() {
		return Label;
	}

	public Statement getStatement() {
		return Statement;
	}

	protected void acceptChildren(Visitor visitor) {
		super.acceptChildren(visitor);
		// Visiting non-text attributes
		if (Statement instanceof Visitable) {
			((Visitable) Statement).accept(visitor);
		}
	}

}
