package org.mesopotamia.lang.java;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.mesopotamia.lang.java.ref.TypeInfo;
import org.mesopotamia.lang.java.ref.TypeSpecInfo;

public class LongConstant extends Constant {

	public LongConstant(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);
	}

	public long getValue() {
		String text = getText();
		if (text.toLowerCase().startsWith("0x")) {
			int lastCharIdx = text.length()-1;
		    long ret=0;
		    String digits=text.substring(2, text.charAt(lastCharIdx)=='L' ? lastCharIdx : text.length());
		    for (int i=0; i<digits.length(); i++) {
		        ret <<= 4;
		        ret |= Character.digit(digits.charAt(i), 16);
		    }
			return ret;
		}
		
		int lastCharIdx = text.length()-1;
		return java.lang.Long.parseLong(Character.toUpperCase(text.charAt(lastCharIdx))=='L' ? text.substring(0, lastCharIdx) : text);		
	}

	@Override
	public TypeSpecInfo getTypeSpecInfo() {
		return new TypeSpecInfo() {

			public int getDimensions() {
				return 0;
			}

			public TypeInfo getTypeInfo() {
				return Long.LONG_INFO;
			}
			
		};
	}
}
