package org.mesopotamia.lang.java;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.mesopotamia.MesopotamiaNode;

public class MesopotamiaJavaNode extends MesopotamiaNode {

	private List<Comment> comments = new ArrayList<Comment>();

	public MesopotamiaJavaNode(String typeName, MesopotamiaJavaNode parent) {
		super(typeName, parent);
	}
	
	public List<Comment> getComments() {
		return Collections.unmodifiableList(comments);
	}
	
	public void addComment(Comment comment) {
		comments.add(comment);
	}
	
	@Override
	public Object clone() throws CloneNotSupportedException {
		MesopotamiaJavaNode ret = (MesopotamiaJavaNode) super.clone();
		ret.comments = comments;
		return ret;
	}

}
