package org.mesopotamia.lang.java;

import java.util.List;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.w3c.dom.Element;

import biz.hammurapi.util.CollectionVisitable;
import biz.hammurapi.util.Visitor;

@SuppressWarnings("unchecked")
public class PackageDefinition extends Identifier {

	public PackageDefinition(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);
			
		// Select attributes
		if (language.supportsTokenName("ANNOTATIONS")) {
			Annotations = select(Annotation.class, "ANNOTATIONS/ANNOTATION");
			firstChild=(Identifier) getChild(1);
		} else {
			firstChild=(Identifier) getChild(0);
		}
	}
	
	Identifier firstChild;

	public void toDom(Element holder) {
		super.toDom(holder);

		// Serialize attributes
		setElement(holder, "Annotations", Annotations);
	}

	// Attributes
	private List<Annotation> Annotations = emptyList;

	// Accessors
	public List<Annotation> getAnnotations() {
		return Annotations;
	}

	protected void acceptChildren(Visitor visitor) {
		super.acceptChildren(visitor);
		// Visiting non-text attributes
		new CollectionVisitable(Annotations, false).accept(visitor);
	}
	
	public String getPath() {
		return firstChild.getPath();
	}

}
