package org.mesopotamia.lang.java;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.mesopotamia.lang.java.ref.Reference;
import org.mesopotamia.lang.java.ref.Scope;
import org.mesopotamia.lang.java.ref.TypeInfo;
import org.mesopotamia.lang.java.ref.TypeSpecInfo;

public class StringConstant extends Constant implements Reference<TypeInfo> {

	public StringConstant(
			NodeData xData, 
			Class<?> context, 
			Scan scan,
			RepositoryLanguage language, 
			Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes

	}

	public TypeInfo getInfo() {
		Scope enclosingScope = findParent(Scope.class);
		return enclosingScope == null ? null : enclosingScope.findType("java.lang.String");
	}

	@Override
	public TypeSpecInfo getTypeSpecInfo() {
		Scope ec = findParent(Scope.class);		
		if (ec==null) {
			return null;
		}
		final TypeInfo stringInfo = ec.findType("java.lang.String");
		return stringInfo == null ? null : new TypeSpecInfo() {

			public int getDimensions() {
				return 0;
			}

			public TypeInfo getTypeInfo() {
				return stringInfo;
			}
			
		};
	}
}
