package org.mesopotamia.lang.java;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.mesopotamia.lang.java.ref.Reference;
import org.mesopotamia.lang.java.ref.Scope;
import org.mesopotamia.lang.java.ref.TypeInfo;
import org.mesopotamia.lang.java.ref.TypeSpecInfo;

public class Super extends PrimaryExpression implements Reference<TypeInfo> {

	public Super(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes

	}

	public TypeInfo getInfo() {
		ClassDefinition enclosingType = findParent(ClassDefinition.class);
		if (enclosingType==null) {
			return null;
		}
		String superStr = enclosingType.getExtends();
		if (superStr==null) {
			superStr = JAVA_LANG_OBJECT;
		}
		Scope scope = enclosingType.findParent(Scope.class);
		return scope == null ? null : scope.findType(superStr);
	}

	@Override
	public TypeSpecInfo getTypeSpecInfo() {
		return new TypeSpecInfo() {

			public int getDimensions() {
				return 0;
			}

			public TypeInfo getTypeInfo() {
				return getInfo();
			}
			
		};
	}
	
}
