package org.mesopotamia.lang.java;

import java.util.List;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.w3c.dom.Element;

import biz.hammurapi.util.CollectionVisitable;
import biz.hammurapi.util.Visitor;

public class Switch extends JavaLanguageElement implements Statement {

	private Expression Expression;

	public Switch(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes
		CasesGroup = select(CasesGroup.class, "CASE_GROUP");
		Expression = (Expression) selectSingleElement(Expression.class, "*[0]");
	}

	public void toDom(Element holder) {
		super.toDom(holder);

		// Serialize attributes
		setElement(holder, "CasesGroup", CasesGroup);
	}
	
	public Expression getExpression() {
		return Expression;
	}

	// Attributes
	private List<CasesGroup> CasesGroup;

	// Accessors
	public List<CasesGroup> getCasesGroup() {
		return CasesGroup;
	}

	protected void acceptChildren(Visitor visitor) {
		super.acceptChildren(visitor);
		// Visiting non-text attributes
		new CollectionVisitable(CasesGroup, false).accept(visitor);
	}

}
