package org.mesopotamia.lang.java;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.w3c.dom.Element;

import biz.hammurapi.util.Visitable;
import biz.hammurapi.util.Visitor;

public class SynchronizedStatement extends JavaLanguageElement implements Statement {

	public SynchronizedStatement(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes
		Expression = (Expression) selectSingleElement(Expression.class, "EXPR");
		CompoundStatement = selectSingleElement(CompoundStatement.class, "SLIST");

	}

	public void toDom(Element holder) {
		super.toDom(holder);

		// Serialize attributes
		setElement(holder, "Expression", Expression);
		setElement(holder, "CompoundStatement", CompoundStatement);
	}

	// Attributes
	private Expression Expression;

	private CompoundStatement CompoundStatement;

	// Accessors
	public Expression getExpression() {
		return Expression;
	}

	public CompoundStatement getCompoundStatement() {
		return CompoundStatement;
	}

	protected void acceptChildren(Visitor visitor) {
		super.acceptChildren(visitor);
		// Visiting non-text attributes
		if (Expression instanceof Visitable) {
			((Visitable) Expression).accept(visitor);
		}
		if (CompoundStatement instanceof Visitable) {
			((Visitable) CompoundStatement).accept(visitor);
		}
	}

}
