package org.mesopotamia.lang.java;

import org.mesopotamia.LanguageElement;
import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.mesopotamia.lang.java.ref.Reference;
import org.mesopotamia.lang.java.ref.Scope;
import org.mesopotamia.lang.java.ref.TypeInfo;
import org.mesopotamia.lang.java.ref.TypeSpecInfo;

public class This extends PostfixExpression implements Reference<TypeInfo> {

	public This(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes

	}

	public TypeInfo getInfo() {
		LanguageElement provider = getProvider();
		if (provider instanceof Expression) {
			return TypeSpecification.toTypeInfo(((Expression) provider).getTypeSpecInfo(), findParent(Scope.class));
		}
		return findParent(TypeDefinitionOrAnonymous.class);
	}
	
	@Override
	public TypeSpecInfo getTypeSpecInfo() {
		return new TypeSpecInfo() {

			public int getDimensions() {
				return 0;
			}

			public TypeInfo getTypeInfo() {
				return getInfo();
			}
			
		};
	}

}
