package org.mesopotamia.lang.java;

import java.util.List;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.w3c.dom.Element;

import biz.hammurapi.util.CollectionVisitable;
import biz.hammurapi.util.Visitable;
import biz.hammurapi.util.Visitor;

public class TryBlock extends JavaLanguageElement implements Statement {

	public TryBlock(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes
		CompoundStatement = selectSingleElement(CompoundStatement.class, "SLIST");
		Handlers = select(Handler.class, "LITERAL_catch");
		FinallyClause = selectSingleElement(CompoundStatement.class,
				"LITERAL_finally/SLIST");

	}

	public void toDom(Element holder) {
		super.toDom(holder);

		// Serialize attributes
		setElement(holder, "CompoundStatement", CompoundStatement);
		setElement(holder, "Handlers", Handlers);
		setElement(holder, "FinallyClause", FinallyClause);
	}

	// Attributes
	private CompoundStatement CompoundStatement;

	private List<Handler> Handlers;

	private CompoundStatement FinallyClause;

	// Accessors
	public CompoundStatement getCompoundStatement() {
		return CompoundStatement;
	}

	public List<Handler> getHandlers() {
		return Handlers;
	}

	public CompoundStatement getFinallyClause() {
		return FinallyClause;
	}

	protected void acceptChildren(Visitor visitor) {
		super.acceptChildren(visitor);
		// Visiting non-text attributes
		if (CompoundStatement instanceof Visitable) {
			((Visitable) CompoundStatement).accept(visitor);
		}
		new CollectionVisitable(Handlers, false).accept(visitor);
		if (FinallyClause instanceof Visitable) {
			((Visitable) FinallyClause).accept(visitor);
		}
	}

}
