package org.mesopotamia.lang.java;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.w3c.dom.Element;

import biz.hammurapi.util.Visitable;
import biz.hammurapi.util.Visitor;

public class TypeBound extends JavaLanguageElement {

	public TypeBound(
			NodeData xData, 
			Class<?> context, 
			Scan scan,
			RepositoryLanguage language, 
			Object environment) throws MesopotamiaException {
		
		super(xData, context, scan, language, environment);

		// Select attributes
		Type = (Identifier) selectSingleElement(Identifier.class, "#org.mesopotamia.lang.java.ClassOrInterfaceType");

	}

	public void toDom(Element holder) {
		super.toDom(holder);

		// Serialize attributes
		setElement(holder, "Type", Type);
	}

	// Attributes
	private Identifier Type;

	// Accessors
	public Identifier getBoundType() {
		return Type;
	}

	protected void acceptChildren(Visitor visitor) {
		super.acceptChildren(visitor);
		// Visiting non-text attributes
		if (Type instanceof Visitable) {
			((Visitable) Type).accept(visitor);
		}
	}

}
