package org.mesopotamia.lang.java;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.mesopotamia.lang.java.ref.TypeSpecInfo;
import org.w3c.dom.Element;

import biz.hammurapi.util.Visitable;
import biz.hammurapi.util.Visitor;

public class Typecast extends UnaryExpressionNotPlusMinus {

	public Typecast(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes
		Expression = selectSingleElement(UnaryExpression.class,
				"#org.mesopotamia.lang.java.UnaryExpression");
		TypeSpecification = selectSingleElement(TypeSpecification.class, "TYPE");

	}

	public void toDom(Element holder) {
		super.toDom(holder);

		// Serialize attributes
		setElement(holder, "Expression", Expression);
		setElement(holder, "TypeSpecification", TypeSpecification);
	}

	// Attributes
	private UnaryExpression Expression;

	private TypeSpecification TypeSpecification;

	// Accessors
	public UnaryExpression getExpression() {
		return Expression;
	}

	public TypeSpecification getTypeSpecification() {
		return TypeSpecification;
	}

	protected void acceptChildren(Visitor visitor) {
		super.acceptChildren(visitor);
		// Visiting non-text attributes
		if (Expression instanceof Visitable) {
			((Visitable) Expression).accept(visitor);
		}
		if (TypeSpecification instanceof Visitable) {
			((Visitable) TypeSpecification).accept(visitor);
		}
	}
	
	@Override
	public TypeSpecInfo getTypeSpecInfo() {
		return getTypeSpecification();
	}

}
