package org.mesopotamia.lang.java;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.w3c.dom.Element;

import biz.hammurapi.util.Visitable;
import biz.hammurapi.util.Visitor;

public class VariableInitializer extends JavaLanguageElement {

	public VariableInitializer(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes
		Initializer = (Initializer) selectSingleElement(Initializer.class,
				"#org.mesopotamia.lang.java.Initializer");

	}

	public void toDom(Element holder) {
		super.toDom(holder);

		// Serialize attributes
		setElement(holder, "Initializer", Initializer);
	}

	// Attributes
	private Initializer Initializer;

	// Accessors
	public Initializer getInitializer() {
		return Initializer;
	}

	protected void acceptChildren(Visitor visitor) {
		super.acceptChildren(visitor);
		// Visiting non-text attributes
		if (Initializer instanceof Visitable) {
			((Visitable) Initializer).accept(visitor);
		}
	}

}
