package org.mesopotamia.lang.java;

import java.util.List;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.mesopotamia.lang.java.ref.MethodInfo;
import org.mesopotamia.lang.java.ref.PrimitiveTypeInfo;
import org.mesopotamia.lang.java.ref.TypeInfo;
import org.mesopotamia.lang.java.ref.VariableInfo;

public class Void extends BuiltInType {

	public Void(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes

	}

	public static final TypeInfo VOID_INFO = new PrimitiveTypeInfo() {

		public TypeInfo getDeclaringType() {
			return null;
		}

		public String getFcn() {
			return "void";
		}

		public List<String> getModifiers() {
			return null;
		}

		public String getName() {
			return "void";
		}

		public TypeInfo findNestedType(String name) {
			return null;
		}

		public MethodInfo findTypeMethod(String name, String[] parameterTypes) {
			return null;
		}

		public VariableInfo findTypeVariable(String name) {
			return null;
		}

		public boolean isKindOf(String superFcn) {
			return "void".equals(superFcn);
		}
		
		public MethodInfo findConstructor(String[] parameterTypes) {
			return null;
		}
		
	};

	public TypeInfo getInfo() {
		return VOID_INFO;
	}
}
