package org.mesopotamia.lang.java;

import org.mesopotamia.MesopotamiaException;
import org.mesopotamia.NodeData;
import org.mesopotamia.RepositoryLanguage;
import org.mesopotamia.Scan;
import org.w3c.dom.Element;

import biz.hammurapi.util.Visitable;
import biz.hammurapi.util.Visitor;

public class WildcardType extends TypeArgument {

	public WildcardType(NodeData xData, Class<?> context, Scan scan,
			RepositoryLanguage language, Object environment) throws MesopotamiaException {
		super(xData, context, scan, language, environment);

		// Select attributes
		TypeBound = selectSingleElement(TypeBound.class, "#org.mesopotamia.lang.java.TypeBound");

	}

	public void toDom(Element holder) {
		super.toDom(holder);

		// Serialize attributes
		setElement(holder, "TypeBound", TypeBound);
	}

	// Attributes
	private TypeBound TypeBound;

	// Accessors
	public TypeBound getTypeBound() {
		return TypeBound;
	}

	protected void acceptChildren(Visitor visitor) {
		super.acceptChildren(visitor);
		// Visiting non-text attributes
		if (TypeBound instanceof Visitable) {
			((Visitable) TypeBound).accept(visitor);
		}
	}

}
