/*
 * mesopotamia-java @mesopotamia.version@
 * Multilingual parser and repository. 
 * Copyright (C) 2005  Hammurapi Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * URL: http://http://www.hammurapi.biz
 * e-Mail: support@hammurapi.biz
 */

package org.mesopotamia.lang.java.javadoc;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import antlr.collections.AST;

/**
 * @author Pavel Vlasov	
 * @version $Revision: 1.1 $
 */
public class FormalSentence {
	
	private List<String> words; 
	
	public FormalSentence(AST node) {
		List<String> words = new ArrayList<String>();
		for (AST child = node.getFirstChild(); child!=null; child = child.getNextSibling()) {
			words.add(child.getText());
		}
		this.words=Collections.unmodifiableList(words);
	}
	
	/**
	 * @return List of strings
	 */
	public List<String> getWords() {
		return words;
	}
	
	public String toString() {
		StringBuilder ret = new StringBuilder();
		for (String word: words) {
			ret.append(word);
			ret.append(" ");
		}
		return ret.toString();
	}
}
