package org.mesopotamia.lang.java.ref;

import java.util.List;


/**
 * Base interface representing information about referenced language construct.
 * For types info scope is type scope, for variables - variable type scope, for methods - return
 * type scope.
 * @author Pavel
 *
 */
public interface Info {
	
	/**
	 * @return Fully qualified name. Null for local variables
	 * and local and anonymous classes/interfaces.
	 */
	String getFcn();
	
	/**
	 * @return Variable, type of method name.
	 */
	String getName();
	
	/**
	 * @return Information about declaring type. 
	 * Null for local variables and local and anonymous classes. 
	 */
	TypeInfo getDeclaringType();

	List<String> getModifiers();
}
