package org.mesopotamia.lang.java.ref;


public interface TypeInfo extends Info {

	/**
	 * @param superFcn Fully qualified name of superclass or superinterface.
	 * @return true if class/interface represented by this type info is the same
	 * or subclass or subinterface of class/interface with name passed in superFcn 
	 * parameter.
	 */
	boolean isKindOf(String superFcn);
	
	TypeInfo findNestedType(String name);
	
	VariableInfo findTypeVariable(String name);
	
	MethodInfo findTypeMethod(String name, String[] argumentTypes);
	
	MethodInfo findConstructor(String[] argumentTypes);

	// TODO - annotations, type parameters.
}
