package org.mesopotamia.lang.java.ref.bcel;

import org.apache.bcel.util.ClassLoaderRepository;
import org.mesopotamia.lang.java.ref.Scope;
import org.mesopotamia.lang.java.ref.TypeInfo;

public class JavaClassTypeInfoRepository {
	
	private ClassLoaderRepository repository;

	public JavaClassTypeInfoRepository(ClassLoader classLoader) {
		this.repository = new ClassLoaderRepository(classLoader);
	}
	
	/**
	 * 
	 * @param name
	 * @param scope
	 * @return type info or null if type info is not found. 
	 */
	public TypeInfo getTypeInfo(String fcn, Scope scope) {
		try {
			return new JavaClassTypeInfo(repository.loadClass(fcn), scope, this);
		} catch (ClassNotFoundException e) {
			return null;
		}
	}
	
	public ClassLoaderRepository getRepository() {
		return repository;
	}

}
