package org.mesopotamia.lang.java.ref.bcel;

import java.util.List;

import org.apache.bcel.classfile.Field;
import org.mesopotamia.lang.java.ref.Scope;
import org.mesopotamia.lang.java.ref.TypeInfo;
import org.mesopotamia.lang.java.ref.TypeSpecInfo;
import org.mesopotamia.lang.java.ref.VariableInfo;

public class JavaClassVariableInfo implements VariableInfo {
	
	private Field field;
	private JavaClassTypeInfoRepository repository;
	private TypeInfo declaringType;
	private Scope scope;

	JavaClassVariableInfo(Field field, Scope scope, JavaClassTypeInfoRepository repository, TypeInfo declaringType) {
		this.field = field;
		this.repository = repository;
		this.declaringType = declaringType;
		this.scope = scope;
	}

	public TypeSpecInfo getTypeSpecification() {
		return JavaClassTypeInfo.type2TypeSpecInfo(field.getType(), scope, repository);
	}

	public TypeInfo getDeclaringType() {
		return declaringType;
	}

	public String getFcn() {
		return declaringType.getFcn()+"."+field.getName();
	}

	public List<String> getModifiers() {
		return JavaClassTypeInfo.modifiersList(field.getModifiers());
	}

	public String getName() {
		return field.getName();
	}

	@Override
	public String toString() {
		return field.getSignature() +" ["+getClass().getName()+"]";
	}
}
